/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000-2001 Sakai Hiroaki.                         */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* Enemy 饹(ץ쥤䡼Υ饹)Υ饤֥(Τ)                */
/*****************************************************************************/

#ifndef _NADAR_SHARE_ENEMYP_H_INCLUDED_
#define _NADAR_SHARE_ENEMYP_H_INCLUDED_

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

#include "PlayerP.h"

#include "Enemy.h"

#define ENEMY_STATE_NONE   0
#define ENEMY_STATE_ESCAPE 1
#define ENEMY_STATE_ATTACK 2
#define ENEMY_STATE_CHASE  3
#define ENEMY_STATE_WAIT   4

#define ENEMY_ACTIONS_BUFFER_SIZE 32

typedef struct _Enemy {
  _Player player; /* ץ쥤䡼Ѿ */
  int type; /*  */

  int state;

  /*
   * ץ쥤䡼֤ϥåȤȤݻ뤳ȤǤ롥
   * ˤơߥưŪ˺뤿ᡤåȤȤݻƤ
   * ʤ(ĤäƤ뤫⤷ʤ)
   */
  Tank target;

  unsigned long int actions[ENEMY_ACTIONS_BUFFER_SIZE];
  int actions_num;
  int current_action;
  int chase_timer;
  int escape_timer;
} _Enemy;

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

#endif /* _NADAR_SHARE_ENEMYP_H_INCLUDED_ */

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
